--
--  Copyright (C) 2011-2014 Reto Buerki <reet@codelabs.ch>
--  Copyright (C) 2011-2014 Adrian-Ken Rueegsegger <ken@codelabs.ch>
--
--  This program is free software; you can redistribute it and/or modify it
--  under the terms of the GNU General Public License as published by the
--  Free Software Foundation; either version 2 of the License, or (at your
--  option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
--
--  This program is distributed in the hope that it will be useful, but
--  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
--  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
--  for more details.
--
--  As a special exception, if other files instantiate generics from this
--  unit,  or  you  link  this  unit  with  other  files  to  produce  an
--  executable   this  unit  does  not  by  itself  cause  the  resulting
--  executable to  be  covered by the  GNU General  Public License.  This
--  exception does  not  however  invalidate  any  other reasons why  the
--  executable file might be covered by the GNU Public License.
--

with Anet.OS_Constants;

package Anet.Sockets.Thin.Packet is

   type Sockaddr_Ll_Type is record
      Sa_Family   : Interfaces.C.unsigned_short := OS_Constants.AF_PACKET;
      --  Address family (always AF_PACKET)
      Sa_Protocol : Interfaces.C.unsigned_short := 0;
      --  Physical layer protocol
      Sa_Ifindex  : Interfaces.C.int            := 0;
      --  Interface number
      Sa_Hatype   : Interfaces.C.unsigned_short := 0;
      --  Header type
      Sa_Pkttype  : Interfaces.C.unsigned_char  := 0;
      --  Packet type
      Sa_Halen    : Interfaces.C.unsigned_char  := 0;
      --  Length of address
      Sa_Addr     : Hardware_Addr_Type (1 .. 8) := (others => 0);
      --  Physical layer address
   end record;
   pragma Convention (C, Sockaddr_Ll_Type);
   --  Device independent physical layer address

end Anet.Sockets.Thin.Packet;
